"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const supertest_1 = require("supertest");
const server_1 = require("./server");
describe('Library example', () => {
    let server;
    beforeEach(async () => {
        server = await (0, server_1.newServer)();
        await server.start();
    });
    afterEach(() => server.stop());
    it('should work', async () => {
        const book = await (0, supertest_1.agent)(server.listeningUrl()).get('/books/123');
        expect(book.status).toBe(200);
        const books = await (0, supertest_1.agent)(server.listeningUrl()).get('/books?page=2');
        expect(books.status).toBe(200);
        const author = await (0, supertest_1.agent)(server.listeningUrl())
            .post('/authors')
            .send({ firstName: 'John', lastName: 'Doe' });
        expect(author.status).toBe(201);
    });
});
//# sourceMappingURL=library.acceptance.js.map