"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getBook = exports.getBooks = void 0;
// routes/books.ts
const chance_1 = __importDefault(require("chance"));
const lodash_1 = require("lodash");
const faker = new chance_1.default('1234');
const bookTemplate = {
    id: `${faker.natural()}`,
    name: faker.word(),
    authors: (0, lodash_1.times)(2, () => ({
        id: faker.natural(),
        firstname: faker.first(),
        lastname: faker.last(),
    })),
};
exports.getBooks = {
    method: 'GET',
    collection: true,
    collectionSize: 3,
    path: '/books',
    template: bookTemplate,
    container: {
        data: (ctx, data) => data,
        count: (ctx, data) => data.length,
        next: (ctx) => { var _a; return ((_a = ctx.query) === null || _a === void 0 ? void 0 : _a.page) === '1' ? 2 : null; },
        previous: (ctx) => { var _a; return ((_a = ctx.query) === null || _a === void 0 ? void 0 : _a.page) === '2' ? 1 : null; },
    },
};
exports.getBook = {
    method: 'GET',
    path: '/books/{id}',
    template: {
        id: (ctx) => { var _a; return (_a = ctx.params) === null || _a === void 0 ? void 0 : _a.id; },
        name: faker.word(),
        authors: (0, lodash_1.times)(2, () => ({
            id: faker.natural(),
            firstname: faker.first(),
            lastname: faker.last(),
        })),
    },
};
//# sourceMappingURL=books.js.map