"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.processCollection = exports.isCollection = void 0;
/* eslint-disable @typescript-eslint/no-use-before-define */
const lodash_1 = require("lodash");
const template_processor_1 = require("./template-processor");
function isCollection(config) {
    return !(0, lodash_1.isNil)(config.collection);
}
exports.isCollection = isCollection;
async function processCollection(config, context) {
    const size = processCollectionSize(config, context);
    return Promise.all((0, lodash_1.times)(size, () => (0, template_processor_1.processTemplate)(config.template, context)));
}
exports.processCollection = processCollection;
function processCollectionSize(config, context) {
    const size = config.collectionSize;
    if ((0, lodash_1.isNumber)(size)) {
        return size;
    }
    return size(context);
}
//# sourceMappingURL=collection-processor.js.map