"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.processContainer = void 0;
/* eslint-disable @typescript-eslint/no-use-before-define */
const bluebird_1 = __importDefault(require("bluebird"));
const lodash_1 = require("lodash");
function processContainer(container, context, generatedBody) {
    let result = container;
    if ((0, lodash_1.isFunction)(container)) {
        result = container(context, generatedBody);
    }
    if (isContainerObject(container)) {
        result = bluebird_1.default.reduce(Object.entries(container), processObjectKey(context, generatedBody), {});
    }
    if (!isPromise(result)) {
        return Promise.resolve(result);
    }
    return result;
}
exports.processContainer = processContainer;
// eslint-disable-next-line @typescript-eslint/no-explicit-any
function isPromise(value) {
    // eslint-disable-next-line @typescript-eslint/no-unsafe-member-access
    return !!value && 'function' === typeof value.then;
}
// eslint-disable-next-line @typescript-eslint/no-explicit-any
function isContainerObject(value) {
    return (0, lodash_1.isPlainObject)(value);
}
function processObjectKey(context, generatedBody) {
    return async (result, [key, value]) => {
        result[key] = (await processContainer(value, context, generatedBody));
        return result;
    };
}
//# sourceMappingURL=container-processor.js.map