"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.processTemplate = void 0;
/* eslint-disable @typescript-eslint/no-use-before-define */
const bluebird_1 = __importDefault(require("bluebird"));
const lodash_1 = require("lodash");
function processTemplate(template, context) {
    let result = template;
    if ((0, lodash_1.isFunction)(template)) {
        result = template(context);
    }
    if (isTemplateObject(template)) {
        result = bluebird_1.default.reduce(Object.entries(template), processObjectKey(context), {});
    }
    if (!isPromise(result)) {
        return Promise.resolve(result);
    }
    return result;
}
exports.processTemplate = processTemplate;
// eslint-disable-next-line @typescript-eslint/no-explicit-any
function isPromise(value) {
    // eslint-disable-next-line @typescript-eslint/no-unsafe-member-access
    return !!value && 'function' === typeof value.then;
}
// eslint-disable-next-line @typescript-eslint/no-explicit-any
function isTemplateObject(value) {
    return (0, lodash_1.isPlainObject)(value);
}
function processObjectKey(context) {
    return async (result, [key, value]) => {
        result[key] = (await processTemplate(value, context));
        return result;
    };
}
//# sourceMappingURL=template-processor.js.map