"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.buildFromDirectory = exports.buildFromRouteConfig = void 0;
/* eslint-disable @typescript-eslint/no-use-before-define */
const globby_1 = __importDefault(require("globby"));
const processors_1 = require("./processors");
const lodash_1 = require("lodash");
function buildFromRouteConfig(routes) {
    return routes.map(route => routerFromConfig(route));
}
exports.buildFromRouteConfig = buildFromRouteConfig;
async function buildFromDirectory(path) {
    const files = await (0, globby_1.default)(path, {
        expandDirectories: { files: ['*.ts', '*.js'] },
    });
    return ((await Promise.all(files.map(f => Promise.resolve().then(() => __importStar(require(f))))))
        // Get all values exported via `export const XXX =`
        .flatMap(exports => Object.values(exports))
        .filter(isValidRouteConfig)
        .map(route => routerFromConfig(route)));
}
exports.buildFromDirectory = buildFromDirectory;
function routerFromConfig(config) {
    return {
        method: config.method,
        path: config.path,
        handler: context => generate(config, context),
    };
}
async function generate(config, context) {
    return {
        status: (0, processors_1.processStatus)(config, context),
        body: await (0, processors_1.processBody)(config, context),
    };
}
// eslint-disable-next-line @typescript-eslint/no-explicit-any
function isValidRouteConfig(input) {
    return (
    // eslint-disable-next-line @typescript-eslint/no-unsafe-member-access
    (0, lodash_1.isString)(input.method) && (0, lodash_1.isString)(input.path) && !(0, lodash_1.isNil)(input.template));
}
//# sourceMappingURL=route-builder.js.map